;-------------------------------
; .align $100
irq_soci_1      ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr soci_wjazd_vic_setup

                ldx #$01
                dex
                bne *-1
                bit $ea
                bit $ea

                lda #(RASTER_LINE_SOCI + 9)
                cmp $d012
                bne *-3

                ldx irq_counter
                lda fld_sinus,x ; fetch number of fld lines
                cmp #$ff
                beq finish_fld
                tax
                beq skip_if_no_fld

fld_loop        lda $d012
                cmp $d012
                beq *-3

                clc
                lda $d011
                adc #1
                and #7
                ora #$18
                sta $d011

                dex
                bne fld_loop

skip_if_no_fld  inc irq_counter

                ldx #<irq_welcome_7
                ldy #>irq_welcome_7
                lda #$00
                rts

finish_fld      lda #$00
                sta irq_counter

                ldx #<irq_welcome_8
                ldy #>irq_welcome_8
                lda #$00
                rts
;-------------------------------
; .align $100
irq_soci_2      ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr soci_wjazd_vic_setup

                ldx irq_counter
                lda zatrzesienie_d016,x
                sta $d016

                inc irq_counter
                lda irq_counter
                cmp #ZATRZESIENIE_D016_COUNT
                beq *+9

                ldx #<irq_welcome_8
                ldy #>irq_welcome_8
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_9
                ldy #>irq_welcome_9
                lda #$00
                rts
;-------------------------------
; .align $100
irq_soci_3      ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr soci_wjazd_vic_setup

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BETWEEN_SOCI_AND_QUESTION_MARK
                beq *+9

                ldx #<irq_welcome_9
                ldy #>irq_welcome_9
                lda #$00
                rts

                lda #$00
                sta irq_counter
                lda #FALLING_SPRITE_START_POSITION_Y
                sta sprites_move_position_y

                ldx #<irq_question_top_1
                ldy #>irq_question_top_1
                lda #$00
                rts
;-------------------------------
zatrzesienie_d016 .db $00,$07,$03,$05,$01,$06,$02
                  .db $00,$03,$00,$02,$01,$02,$00
;-------------------------------
ZATRZESIENIE_D016_COUNT = *-zatrzesienie_d016
;-------------------------------
fld_sinus
#include "target/fld-sinus-table.inc"
;-------------------------------
