;-------------------------------
#macro quick_copy_39_bytes_from_AA_to_BB(AA,BB) {

                lda {AA} + $00
                sta {BB} + $00
                lda {AA} + $01
                sta {BB} + $01
                lda {AA} + $02
                sta {BB} + $02
                lda {AA} + $03
                sta {BB} + $03
                lda {AA} + $04
                sta {BB} + $04
                lda {AA} + $05
                sta {BB} + $05
                lda {AA} + $06
                sta {BB} + $06
                lda {AA} + $07
                sta {BB} + $07
                lda {AA} + $08
                sta {BB} + $08
                lda {AA} + $09
                sta {BB} + $09
                lda {AA} + $0a
                sta {BB} + $0a
                lda {AA} + $0b
                sta {BB} + $0b
                lda {AA} + $0c
                sta {BB} + $0c
                lda {AA} + $0d
                sta {BB} + $0d
                lda {AA} + $0e
                sta {BB} + $0e
                lda {AA} + $0f
                sta {BB} + $0f
                lda {AA} + $10
                sta {BB} + $10
                lda {AA} + $11
                sta {BB} + $11
                lda {AA} + $12
                sta {BB} + $12
                lda {AA} + $13
                sta {BB} + $13
                lda {AA} + $14
                sta {BB} + $14
                lda {AA} + $15
                sta {BB} + $15
                lda {AA} + $16
                sta {BB} + $16
                lda {AA} + $17
                sta {BB} + $17
                lda {AA} + $18
                sta {BB} + $18
                lda {AA} + $19
                sta {BB} + $19
                lda {AA} + $1a
                sta {BB} + $1a
                lda {AA} + $1b
                sta {BB} + $1b
                lda {AA} + $1c
                sta {BB} + $1c
                lda {AA} + $1d
                sta {BB} + $1d
                lda {AA} + $1e
                sta {BB} + $1e
                lda {AA} + $1f
                sta {BB} + $1f
                lda {AA} + $20
                sta {BB} + $20
                lda {AA} + $21
                sta {BB} + $21
                lda {AA} + $22
                sta {BB} + $22
                lda {AA} + $23
                sta {BB} + $23
                lda {AA} + $24
                sta {BB} + $24
                lda {AA} + $25
                sta {BB} + $25
                lda {AA} + $26
                sta {BB} + $26
}
;-------------------------------
#macro copy_39_bytes_from_Z1_to_Z2() {

                ldy #$00
                lda (Z1),y
                sta (Z2),y
                iny
                cpy #$27
                bne *-7
}
;-------------------------------
#macro copy_312_bytes_from_Z1_to_Z2() {

                ldy #$00
                lda (Z1),y
                sta (Z2),y
                iny
                bne *-5
                inc Z1 + $01
                inc Z2 + $01
                lda (Z1),y
                sta (Z2),y
                iny
                cpy #$38
                bne *-7
}
;-------------------------------
#macro add_byte_value_to_zero_page_variable(var,val) {

                clc
                lda {var} + $00
                adc #{val}
                sta {var} + $00
                bcc *+4
                inc {var} + $01
}
;-------------------------------
; AA < BB => .C = 0
; AA >= BB => .C = 1
#macro a_less_than_b(AA,BB) {
                sec
                lda {AA}
                sbc {BB}
}
;-------------------------------
#macro setup_next_irq_to_rewrite_colors_data(IRQ) {

                lda shift_frame_counter
                cmp #(num_s_d016_frames-1)
                bne *+9

                lda #$80
                ldx #<{IRQ}
                ldy #>{IRQ}
                rts
}
;-------------------------------
#macro rewrite_screen_data(FROM_TO) {

                lda shift_frame_counter
                cmp #$08
                bne *+5
                jmp rewrite_{FROM_TO}_screen_data_15_rows

                cmp #$09
                bne *+5
                jmp rewrite_{FROM_TO}_screen_data_10_rows

                rts
}
;-------------------------------
#macro rewrite_routine_selector(FROM,TO) {

                .a_less_than_b(shift_frame_counter,#$09)
                bcc *+13

                lda #<rewrite_Z1_to_Z2_do_nothing
                sta rewrite_bitmap_{FROM}_to_{TO}_routine_runner_lo
                lda #>rewrite_Z1_to_Z2_do_nothing
                sta rewrite_bitmap_{FROM}_to_{TO}_routine_runner_hi
                rts

                lda shift_frame_counter
                cmp #$08
                bne *+15

                lda #<rewrite_Z1_to_Z2_one_bitmap_row
                sta rewrite_bitmap_{FROM}_to_{TO}_routine_runner_lo
                lda #>rewrite_Z1_to_Z2_one_bitmap_row
                sta rewrite_bitmap_{FROM}_to_{TO}_routine_runner_hi
                jmp *+13

                lda #<rewrite_Z1_to_Z2_three_bitmap_rows
                sta rewrite_bitmap_{FROM}_to_{TO}_routine_runner_lo
                lda #>rewrite_Z1_to_Z2_three_bitmap_rows
                sta rewrite_bitmap_{FROM}_to_{TO}_routine_runner_hi

                ; Select source and target bitmap data vectors:
                ldx shift_frame_counter

                lda rewrite_bitmap_{FROM}_lo,x
                clc
                adc #$08
                sta Z1 + $00
                lda rewrite_bitmap_{FROM}_hi,x
                sta Z1 + $01

                lda rewrite_bitmap_{TO}_lo,x
                sta Z2 + $00
                lda rewrite_bitmap_{TO}_hi,x
                sta Z2 + $01

                rts
}
;-------------------------------
