;-------------------------------
; FREE MEMORY:
; $3b00-$5000 - between music and code
; $8400-$a000 - between both displayed screens/bitmaps
; $c000-$d000 - after second bitmap
;-------------------------------

;-------------------------------
CREDITS_START_ADDRESS = $5000
CREDITS_NEXT_PART_START_ADDRESS = $c000
;-------------------------------

;-------------------------------
BORDER_COLOUR = $06
BCKGRD_COLOUR = $06
IMAGE_COLOUR  = $01
SCREEN_FILL   = (IMAGE_COLOUR << 4 | BCKGRD_COLOUR)
;-------------------------------
DEPACK_TIME     = $40
;-------------------------------

;-------------------------------
BITMAP_1 = $6000
SCREEN_1 = $5c00
SCREEN_BLANK = $5800
;-------------------------------
BITMAP_2 = $a000
SCREEN_2 = $8000
;-------------------------------

;-------------------------------
SCREEN_1_D018_BITMAP = ((BITMAP_1 & $3fff) >> 10)
SCREEN_1_D018_SCREEN = ((SCREEN_1 & $3fff) >> 10 << 4)
SCREEN_1_D018        = (SCREEN_1_D018_BITMAP | SCREEN_1_D018_SCREEN)
SCREEN_1_DD00        = ((BITMAP_1 >> 14)  ^ $03)
;-------------------------------
SCREEN_2_D018_BITMAP = ((BITMAP_2 & $3fff) >> 10)
SCREEN_2_D018_SCREEN = ((SCREEN_2 & $3fff) >> 10 << 4)
SCREEN_2_D018        = (SCREEN_2_D018_BITMAP | SCREEN_2_D018_SCREEN)
SCREEN_2_DD00        = ((BITMAP_2 >> 14)  ^ $03)
;-------------------------------

;-------------------------------
; Z1            = $40;/$41
; Z2            = $42;/$43
; Z3            = $44;/$45
;-------------------------------
