#!/usr/bin/perl

use strict;
use warnings;

my $screen_y;

for (my $y = 0; $y < 25; $y++) {
  $screen_y .= sprintf "                .db <(SCREEN + \$28 * \$%02x)\n", $y;
}

print_comment();

$screen_y =~ s/^.{9}/screen_lo/;
print $screen_y;

print_comment();

$screen_y =~ s/^.{9}/screen_hi/;
$screen_y =~ tr/</>/;

print $screen_y;

print_comment();

sub print_comment {
  print qq{;-------------------------------\n};
}
