#!/usr/bin/perl
#
# tools/scripts/setup-part-names.pl > part-names.cfg

use utf8;
use bytes;
use strict;
use warnings;

use FindBin qw($Bin);
use lib "$Bin/../lib";
use Demo::Config;

my %part_names = Demo::Config->new()->setup_part_file_names();

for my $part_name (sort keys %part_names) {
  print "$part_name = $part_names{$part_name}\n";
}
