;-------------------------------
; IRQ bottom part ("SUCA") during flashing out of "SOCI" -> "SUCA" switch:
; .align $100
irq_suca_1      ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr suca_wjazd_vic_setup

                ldx #<irq_welcome_10
                ldy #>irq_welcome_10
                lda #$00
                rts
;-------------------------------
; IRQ bottom part ("SUCA") during display of "Welcome to SUCA" graphics:
; .align $100
irq_suca_2      ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr suca_wjazd_vic_setup

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BEFORE_EXCLAMATION_MARK_APPEARS
                beq *+9

                ldx #<irq_welcome_11
                ldy #>irq_welcome_11
                lda #$00
                rts

                lda #$00
                sta irq_counter
                lda #RISING_SPRITE_START_POSITION_Y
                sta sprites_move_position_y

                ldx #<irq_exclamation_top_1
                ldy #>irq_exclamation_top_1
                lda #$00
                rts
;-------------------------------
