;-------------------------------
write_new_bitmap_data_to_1

                ldx #<(BITMAP_1 + $0138)
                ldy #>(BITMAP_1 + $0138)

                jmp write_new_bitmap_data
;-------------------------------
write_new_bitmap_data_to_2

                ldx #<(BITMAP_2 + $0138)
                ldy #>(BITMAP_2 + $0138)

                ; jmp write_new_bitmap_data
;-------------------------------
; .X/.Y -> to
write_new_bitmap_data

                stx Z2 + $00
                sty Z2 + $01

                lda SOURCE_BITMAP + $00
                sta Z1 + $00
                lda SOURCE_BITMAP + $01
                sta Z1 + $01

                lda shift_frame_counter
                cmp #$09
                beq *+3
                rts

                ldx #$00

loop_writ_001   ldy #$00
loop_writ_005   lda (Z1),y
                sta (Z2),y
                iny
                cpy #$08
                bne loop_writ_001 + $02

                .add_byte_value_to_zero_page_variable(Z1,$08)
                .add_byte_value_to_zero_page_variable(Z2,$40)
                inc Z2 + $01

                inx
                cpx #$19
                bne loop_writ_001

                jmp move_source_bitmap_vector_to_next
;-------------------------------
; Move SOURCE_BITMAP vector to point to the next column data of a scrolled pic:
move_source_bitmap_vector_to_next

                ; SOURCE_BITMAP += 25 * $08
                .add_byte_value_to_zero_page_variable(SOURCE_BITMAP,$c8)

                rts
;-------------------------------

;-------------------------------
write_new_screen_data_to_1

                lda SOURCE_SCREEN + $00
                sta Z1 + $00
                lda SOURCE_SCREEN + $01
                sta Z1 + $01

                ldx #<(SCREEN_1 + $0027)
                ldy #>(SCREEN_1 + $0027)

                jsr write_new_screen_or_colors_data

                jmp move_source_screen_vector_to_next
;-------------------------------
write_new_screen_data_to_2

                lda SOURCE_SCREEN + $00
                sta Z1 + $00
                lda SOURCE_SCREEN + $01
                sta Z1 + $01

                ldx #<(SCREEN_2 + $0027)
                ldy #>(SCREEN_2 + $0027)

                jsr write_new_screen_or_colors_data

                jmp move_source_screen_vector_to_next
;-------------------------------
; Z1/Z1+1 -> from
; .X/.Y -> to
write_new_screen_or_colors_data

                stx Z2 + $00
                sty Z2 + $01

                ldx #$00

loop_writ_002   ldy #$00
loop_writ_004   lda (Z1),y
                sta (Z2),y

                inc Z1 + $00
                bne *+4
                inc Z1 + $01
                .add_byte_value_to_zero_page_variable(Z2,$28)

                inx
                cpx #$19
                bne loop_writ_002

                rts
;-------------------------------
; Move SOURCE_SCREEN vector to point to the next column data of a scrolled pic:
move_source_screen_vector_to_next

                ; SOURCE_SCREEN += 25 * $01
                .add_byte_value_to_zero_page_variable(SOURCE_SCREEN,$19)

                rts
;-------------------------------

;-------------------------------
write_new_colors_data

                lda SOURCE_COLORS + $00
                sta Z1 + $00
                lda SOURCE_COLORS + $01
                sta Z1 + $01

                ldx #<(COLORS_1 + $0027)
                ldy #>(COLORS_1 + $0027)

                jsr write_new_screen_or_colors_data

                jmp move_source_colors_vector_to_next
;-------------------------------
; Move SOURCE_COLORS vector to point to the next column data of a scrolled pic:
move_source_colors_vector_to_next

                ; SOURCE_COLORS += 25 * $01
                .add_byte_value_to_zero_page_variable(SOURCE_COLORS,$19)

                rts
;-------------------------------
