;-------------------------------
; VERSION A: ABS(Y2 - Y1) > X2 - X1
#macro draw_line_colour_2_dx_lt_dy(suffix_subref,iny_dey)
{
                ; x = X1
                ldx X1

                ; for y from Y1 to Y2
                ldy Y2
                ; {iny_dey}
                sty *+20

                ; Begin with Y1 and loop over incrementing it by +1:
                ldy Y1

                ; error = error + deltaerr
                lda error
                clc
                adc deltaerr
                sta error

                ; if error > 0.5 then
                ; error = error - 1.0
                bcc *+3+3

                ; plot(x,y)
                jsr put_pixel_{suffix_subref}_c_2

                ; x = x + 1
                inx

                {iny_dey}
                ; Loop is terminated when it reaches point beyond Y2:
                cpy #$00
                bne *-16

                rts
}
;-------------------------------
; VERSION B: ABS(Y2 - Y1) = X2 - X1
#macro draw_line_colour_2_dx_eq_dy(suffix_subref,iny_dey)
{
                ldx X2
                ; inx
                stx *+13

                ldy Y1

                ; Begin with X1 and loop over incrementing it by +1:
                ldx X1
                jsr put_pixel_{suffix_subref}_c_2
                inx
                {iny_dey}

                ; Loop is terminated when it reaches point beyond X2:
                cpx #$00
                bne *-7

                rts
}
;-------------------------------
; VERSION C: ABS(Y2 - Y1) < X2 - X1
#macro draw_line_colour_2_dx_gt_dy(suffix_subref,iny_dey)
{
                ; y = Y1
                ldy Y1

                ; for x from X1 to X2
                ldx X2
                ; inx
                stx *+20

                ; Begin with X1 and loop over incrementing it by +1:
                ldx X1

                ; error = error + deltaerr
                lda error
                clc
                adc deltaerr
                sta error

                ; if error > 0.5 then
                ; error = error - 1.0
                bcc *+3

                ; y = y + 1
                {iny_dey}

                ; plot(x,y)
                jsr put_pixel_{suffix_subref}_c_2

                inx
                ; Loop is terminated when it reaches point beyond X2:
                cpx #$00
                bne *-16

                rts
}
;-------------------------------
