#!/usr/bin/perl
#
# tools/scripts/crunch.pl input.prg output.prg e000

use utf8;
use bytes;
use strict;
use warnings;

use Archive::ByteBoozer qw/crunch/;

my ($input, $output, $loading_address) = @ARGV;

my $original = new IO::File $input, 'r';
my $crunched = new IO::File $output, 'w';

crunch(source => $original, target => $crunched, relocate_output => hex ($loading_address), verbose => 1);
