#!/usr/bin/perl
#
# tools/scripts/setup-parts.pl > parts-config.inc

use utf8;
use bytes;
use strict;
use warnings;

use FindBin qw($Bin);
use lib "$Bin/../lib";
use Demo::Config;

my $config = Demo::Config->new();

my $start_addresses = $config->part_start_addresses(as_source_code => 1);
print $start_addresses;

print "\n";

my $loading_addresses = $config->part_loading_addresses(as_source_code => 1);
print $loading_addresses;

print "\n";

my $synchro_timers = $config->part_synchro_timers(as_source_code => 1);
print $synchro_timers;

print "\n";

my $file_names = $config->part_file_names(as_source_code => 1);
print $file_names;
